<template>
  <template-page
    v-if="pageShow"
    ref="pageRef"
    :get-list="getList"
    :exportList="exportList"
    :table-attributes="tableAttributes"
    :table-events="tableEvents"
    :options-evens-group="optionsEvensGroup"
    :moreParameters="moreParameters"
    :column-parsing="columnParsing"
    :operation="operation()"
    key="pageType"
  >
    <div class="cartographer_big">
      <el-dialog title="考核项目" width="100%" :modal="false" :visible.sync="formDialog" :before-close="handleClose">
        <zj-page-container>
          <zj-page-fill>
            <div style="box-sizing: border-box; padding: 20px 20px 0 20px">
              <zj-form-container ref="formRef" :form-data="formData" :form-attributes="{ size: 'mini' }">
                <zj-form-module title="设置" label-width="100px" :form-data="formData" :form-items="formItems">
                </zj-form-module>
              </zj-form-container>
            </div>
          </zj-page-fill>
          <div style="text-align: right; box-sizing: border-box; padding: 16px 20px">
            <el-button size="mini" @click="handleClose">取消</el-button>
            <el-button size="mini" type="primary" @click="save">保存</el-button>
          </div>
        </zj-page-container>
      </el-dialog>
    </div>
  </template-page>
</template>

<script>
import TemplatePage from '@/components/template/template-page-1.vue'
import import_mixin from '@/components/template/import_mixin.js'
import operation_mixin from '@/components/template/operation_mixin.js'
import {
  letterManagerListProject,
  letterManagerListProjectExport,
  letterManagerImportProject,
  letterManagerAddProject,
  letterManagerUpdateProject,
  letterManagerDetailProject,
  letterManagerDelProject
} from '@/api/assessmentItemSetting.js'
import { required } from '@/components/template/rules_verify.js'
import { commonTemplateDownload } from '@/api/common.js'
export default {
  components: { TemplatePage },
  mixins: [import_mixin, operation_mixin],
  data() {
    return {
      pageType: 'list',
      pageShow: true,
      // 表格属性
      tableAttributes: {
        // 启用勾选列
        selectColumn: false
      },
      // 表格事件
      tableEvents: {
        'selection-change': this.selectionChange
      },
      // 勾选选中行
      recordSelected: [],
      /** 表单变量 */
      formDialog: false,
      formData: {
        fraction: '',
        price: '',
        projectId: '',
        projectName: '',
        projectReg: '',
        projectText: '',
        status: ''
      }
    }
  },
  computed: {
    // 事件组合
    optionsEvensGroup() {
      return [
        [
          [
            this.optionsEvensAuth('add', {
              click: this.openForm
            })
          ]
        ],
        [
          [
            this.optionsEvensAuth('import', ({ moduleName }) => {
              return {
                name: moduleName,
                render: () => {
                  return this.importButton(letterManagerImportProject, moduleName)
                }
              }
            })
          ],
          [
            this.optionsEvensAuth('downloadTemplate', {
              click: () => {
                commonTemplateDownload({ name: '违规项目导入模板.xlsx' }, `违规项目导入模板`)
                  .then(res => {
                    this.$message({
                      message: '下载成功',
                      type: 'success'
                    })
                  })
                  .catch(err => {
                    this.$message.error('下载失败')
                  })
              }
            })
          ]
        ]
      ]
    },
    // 更多参数
    moreParameters() {
      return []
    },
    formItems() {
      return [
        {
          md: 12,
          name: 'el-input',
          attributes: {},
          formItemAttributes: {
            label: '考核项目',
            prop: 'projectName',
            rules: [...required]
          }
        },
        {
          md: 12,
          name: 'el-input',
          attributes: {},
          formItemAttributes: {
            label: '考核条例',
            prop: 'projectReg',
            rules: [...required]
          }
        },
        {
          md: 24,
          name: 'el-input',
          attributes: { type: 'textarea', rows: 3 },
          formItemAttributes: {
            label: '考核规定',
            prop: 'projectText',
            rules: [...required]
          }
        },
        {
          md: 8,
          name: 'el-input',
          attributes: {},
          formItemAttributes: {
            label: '考核金额',
            prop: 'price',
            rules: [...required]
          }
        },
        {
          md: 8,
          name: 'el-input',
          attributes: {},
          formItemAttributes: {
            label: '考核分数',
            prop: 'fraction',
            rules: [...required]
          }
        },
        {
          name: 'el-radio',
          options: [
            { label: '启用', value: 'ON' },
            { label: '禁用', value: 'OFF' }
          ],
          md: 6,
          attributes: {
            placeholder: '请输入'
          },
          formItemAttributes: {
            label: '状态',
            prop: 'status',
            rules: [...required]
          }
        }
      ]
    }
  },
  methods: {
    // 列表请求函数
    getList: letterManagerListProject,
    // 列表导出函数
    exportList: letterManagerListProjectExport,
    // 表格列解析渲染数据更改
    columnParsing(item, defaultData) {
      return defaultData
    },
    // 监听勾选变化
    selectionChange(data) {
      this.recordSelected = data
    },
    // 打开创建弹窗
    openForm() {
      this.formDialog = true
    },
    // 打开详情弹窗
    openDetailForm(row) {
      Promise.all([letterManagerDetailProject({ id: row.projectId })]).then(([res1, res2]) => {
        this.formData = { ...res1.data }
        this.formDialog = true
      })
    },
    handleClose() {
      this.$refs?.formRef?.resetFields()
      this.$data.formData = this.$options.data().formData
      this.formDialog = false
    },
    // 操作按钮
    operation() {
      return this.operationBtn({
        edit: {
          click: ({ row, index, column }) => {
            this.openDetailForm(row)
          }
        },
        del: {
          conditions: ({ row, index, column }) => {
            return true
          },
          prompt: '确定删除?',
          click: ({ row, index, column }) => {
            letterManagerDelProject({
              id: row.projectId
            })
              .then(res => {
                this.$refs.pageRef.refreshList()
                this.$message({
                  type: 'success',
                  message: `删除成功!`
                })
              })
              .catch(err => {
                console.log(err)
              })
          }
        }
      })
    },
    // 保存
    save() {
      this.$refs.formRef.validate((valid, invalidFields, errLabels) => {
        if (valid) {
          ;(this.formData?.projectId ? letterManagerUpdateProject : letterManagerAddProject)(this.formData).then(
            res => {
              this.$message({
                type: 'success',
                message: '保存成功'
              })
              this.handleClose()
              this.$refs.pageRef.refreshList()
            }
          )
        }
      })
    }
  }
}
</script>

<style lang="scss" scoped></style>
